<?php
class rhcss_editor_event_page_tickets_box extends module_righthere_css {
	function __construct( $args = array() ) {
		return parent::__construct($args);
	}
	
	function options( $t = array() ) {
		$i = count( $t );
		$extra = array();
			
		//---- tickets box -----
		$box_prefix = 'rhceptb';
		$box_selector = '.rhc-woo-tickets';	
		$with_image = false;
		$fonts_with_values_links = false;
		include 'dbox_options.php';
		//------

		// Qantity Container
		$i++;
		$t[ $i ] = (object) array();
		$t[ $i ]->id = $box_prefix . '-qty-container'; 
		$t[ $i ]->label = __( 'Quantity Container' , 'rhc' );
		$t[ $i ]->options = array();

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_qty_arrows_bg',
			'type'       => 'css',
			'label'      => __( 'Arrows Background', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rh-woo-spinner-container .input-group-btn-vertical > .btn",
			'property'   => 'background-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] =	(object)array(
			'id'           => $box_prefix . '_qty_arrows_color',
			'type'         => 'css',
			'label'        => __( 'Color', 'rhc' ),
			'input_type'   => 'color_or_something_else',
			'holder_class' => '',
			'opacity'      => true,
			'btn_clear'    => true,
			'selector'     => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rh-woo-spinner-container .input-group-btn-vertical > .btn",
			'property'     => 'color',
			'real_time'    => true
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_qty_background',
			'type'       => 'css',
			'label'      => __( 'Quantity Background', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rh-woo-spinner-container .rh-woo-spinner input",
			'property'   => 'background-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_qty_color',
			'type'       => 'css',
			'label'      => __( 'Color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rh-woo-spinner-container .rh-woo-spinner input",
			'property'   => 'color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] =	(object) array(
			'id'           => $box_prefix . '_qty_border',
			'type'         => 'css',
			'label'        => __( 'Border Color', 'rhc' ),
			'input_type'   => 'color_or_something_else',
			'holder_class' => '',
			'opacity'      => true,
			'btn_clear'    => true,
			'selector'     => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rh-woo-spinner-container .rh-woo-spinner input",
			'property'     => 'border-color',
			'real_time'    => true
		);

		// Donation Dropdown
		$i++;
		$t[ $i ] = (object) array();
		$t[ $i ]->id = $box_prefix . '-donation-dropdown'; 
		$t[ $i ]->label = __( 'Donation Dropdown' , 'rhc' );
		$t[ $i ]->options = array();

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_donation_background',
			'type'       => 'css',
			'label'      => __( 'Background color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-donation-options select",
			'property'   => 'background-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_donation_border',
			'type'       => 'css',
			'label'      => __( 'Border color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-donation-options select",
			'property'   => 'border-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_donation_color',
			'type'       => 'css',
			'label'      => __( 'Text color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-donation-options select",
			'property'   => 'color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_donation_arrow',
			'type'       => 'css',
			'label'      => __( 'Arrow color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-donation-options:after",
			'property'   => 'border-top-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		// Show/Hide Details
		$i++;
		$t[ $i ] = (object) array();
		$t[ $i ]->id = $box_prefix . '-details'; 
		$t[ $i ]->label = __( 'Show/Hide Details' , 'rhc' );
		$t[ $i ]->options = array();

		$t[ $i ]->options = $this->add_font_options( $t[ $i ]->options, array(
			'prefix'   => $box_prefix . '_details_link',
			'selector' => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-desc-btn-group a",
			'labels'   => (object) array(
				'family' => __( 'Details Link', 'rhc' ),
				'size'   => __( 'Size', 'rhc' ),
				'color'  => __( 'Color', 'rhc' )				
			)
		));

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_details_divider',
			'type'       => 'css',
			'label'      => __( 'Divider Color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder .rhc-woo-cel-desc",
			'property'   => 'border-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		// Other UI Elements
		$i++;
		$t[ $i ] = (object) array();
		$t[ $i ]->id = $box_prefix . '-ui-elements'; 
		$t[ $i ]->label = __( 'UI Elements' , 'rhc' );
		$t[ $i ]->options = array();

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_ui_sold_out',
			'type'       => 'css',
			'label'      => __( 'Sold Out Background', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder.rhc-woo-holder .rhc-woo-row.rhc-woo-soldout:after",
			'property'   => 'background-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_ui_sales_ended',
			'type'       => 'css',
			'label'      => __( 'Sales Ended Background', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder.rhc-woo-holder .rhc-woo-row.rhc-woo-salesend:after",
			'property'   => 'background-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_ui_divider_top',
			'type'       => 'css',
			'label'      => __( 'Divider Top Color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder.rhc-woo-holder > .rhc-woo-row",
			'property'   => 'border-bottom-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		$t[ $i ]->options[] = (object) array(
			'id'         => $box_prefix . '_ui_divider_bottom',
			'type'       => 'css',
			'label'      => __( 'Divider Bottom Color', 'rhc' ),
			'input_type' => 'color_or_something_else',
			'opacity'    => true,
			'selector'   => ".fe-extrainfo-container$box_selector .fe-extrainfo-holder.rhc-woo-holder > .rhc-woo-row",
			'property'   => 'border-top-color',
			'real_time'  => true,
			'btn_clear'  => true,
			'derived'    => array()
		);

		//-- Saved and DC  -----------------------		
		$i = count( $t );
		$t[ $i ]          = (object) array();
		$t[ $i ]->id      = 'rh-saved-list'; 
		$t[ $i ]->label   = __( 'Templates', 'rhc' );
		$t[ $i ]->options = array(
			(object) array(
				'id'         => 'rh_saved_settings',
				'input_type' => 'backup_list'
			)			
		);

		return $t;
	}
}
?>